/**
 * This class contains unit tests for validating the behavior of Apex classes
 * and triggers.
 *
 * Unit tests are class methods that verify whether a particular piece
 * of code is working properly. Unit test methods take no arguments,
 * commit no data to the database, and are flagged with the testMethod
 * keyword in the method definition.
 *
 * All test methods in an organization are executed whenever Apex code is deployed
 * to a production organization to confirm correctness, ensure code
 * coverage, and prevent regressions. All Apex classes are
 * required to have at least 75% code coverage in order to be deployed
 * to a production organization. In addition, all triggers must have some code coverage.
 * 
 * The @isTest class annotation indicates this class only contains test
 * methods. Classes defined with the @isTest annotation do not count against
 * the organization size limit for all Apex scripts.
 *
 * See the Apex Language Reference for more information about Testing and Code Coverage.
 */
/*------------------------------------------------------------
Author:        Yen Le
Company:       Thirdwave
Description:   a test class created to validate the EquipmentMissingFormBulkClose,
			 EquipmentMissingFormEdit, and EquipmentMissingFormView
History: 	   09-Mar-17 Miro Zelina added test methods for Well Event and Facility add missing form
			 06-jul-17 Miro Zelina added test methods for System & Sub-System add missing form
			 28-Jul-17 Miro Zelina updated test for SAP Support User for bulk close
			 06-Aug-2018 Miro Zelina - added check for not populated FLOC id (isEmptyFloc) [W-001180]

------------------------------------------------------------*/
@IsTest
private class EquipmentMissingFormTest {

	static Field__c field;
	static Route__c route;
	static HOG_Planner_Group__c plannerGroup;

	static void createSampleData() {

		Business_Unit__c businessUnit = new Business_Unit__c(Name = 'Test Business Unit');
		insert businessUnit;

		Business_Department__c businessDepartment = BusinessDepartmentTestData.createBusinessDepartment('Test Business Department');
		insert businessDepartment;

		Operating_District__c operatingDistrict = OperatingDistrictTestData.createOperatingDistrict('Test Field', businessDepartment.Id, businessUnit.Id);
		insert operatingDistrict;

		Id recordTypeId = [SELECT Id FROM RecordType WHERE SobjectType = 'Field__c' AND Name = 'HOG - Control Room Centre Record'].Id;

		field = FieldTestData.createField('Test Field Control Centre', operatingDistrict.Id, recordTypeId);
		insert field;

		route = RouteTestData.createRoute('999');
		insert route;

		plannerGroup = new HOG_Planner_Group__c();
		plannerGroup.Name = '100';
		insert plannerGroup;

		Location__c loc1 = LocationTestData.createLocation('LocationSource', route.Id, field.Id);
		loc1.Planner_Group__c = '100';
		insert loc1;

		Location__c loc2 = LocationTestData.createLocation('LocationDestination', route.Id, field.Id);
		loc2.Planner_Group__c = '120';
		insert loc2;

		HOG_Equipment_Request_Configuration__c settings = new HOG_Equipment_Request_Configuration__c(Equipment_Request_Expiration_Date_Days__c = 60,
				Days_Before_Expiration_Notification__c = 10);
		insert settings;
	}
	@IsTest
	static void testAddEquipmentFormLocation() {

		createSampleData();
		Location__c wellLocation = LocationTestData.createLocation('Location for testing', route.Id, field.Id);
		insert wellLocation;

		//test create a new Add Equipment Form
		PageReference pageRef = Page.EquipmentMissingFormEdit;
		Test.setCurrentPage(pageRef);
		pageRef.getParameters().put('locId', wellLocation.Id);

		Equipment_Missing_Form__c addingForm = new Equipment_Missing_Form__c();
		ApexPages.StandardController stdCtrl = new ApexPages.StandardController(addingForm);
		EquipmentMissingFormControllerX addingFormCtrl = new EquipmentMissingFormControllerX(stdCtrl);
		addingForm = addingFormCtrl.form;

		System.assertEquals(addingForm.Location__c, wellLocation.Id);
		System.assertEquals(addingForm.Status__c, 'Open');
		System.assertEquals(addingForm.Equipment_Status__c, 'Missing');

		System.assert(addingFormCtrl.attachment.Id == null);
		System.assert(addingFormCtrl.serialPlate.Id == null);
		//test validation error: Manufacturer is required
		try {
			addingFormCtrl.save();
		} catch (Exception e) {
			System.assert(false, 'You must enter a value');
		}
		//Serial No is required
		try {
			addingForm.Manufacturer__c = 'TANK';
			addingFormCtrl.save();
		} catch (Exception e) {
			System.assert(false, 'You must enter a value');
		}
		//Serial Plate of Asset is required
		try {
			addingForm.Manufacturer_Serial_No__c = '121342';
			addingFormCtrl.serialPlate.Body = null;
			addingFormCtrl.save();
		} catch (Exception e) {
			System.assert(false, 'You must attach a file');
		}
		//Location is required
		try {
			addingForm.Location__c = null;
			addingFormCtrl.save();
		} catch (Exception e) {
			System.assert(false, 'Please go to a Well Location / Facility / Well Event / System or Sub-System detail page and click the "Add Equipment Form" button on the Equipment related list.');
		}
		addingForm.Manufacturer__c = 'TANK';
		addingForm.Manufacturer_Serial_No__c = '123142';
		addingForm.Status__c = 'Open';
		addingForm.Equipment_Status__c = 'Missing';
		addingForm.Location__c = wellLocation.Id;
		addingForm.Description__c = 'Description';
		addingForm.Model_Number__c = 'Test';
		addingFormCtrl.serialPlate.Name = 'upload attachment';
		addingFormCtrl.serialPlate.Body = Blob.valueOf('testing testing');
		addingFormCtrl.attachment.Name = 'upload attachment 1';
		addingFormCtrl.attachment.Body = Blob.valueOf('testing');

		addingFormCtrl.save();
		//the record is save successfull
		System.assert(stdCtrl.getId() != null);

		//test edit Data Update form
		addingForm = [
				SELECT Comments__c, Id, Equipment_Status__c,
						Manufacturer__c, Manufacturer_Serial_No__c, Location__c,
						Model_Number__c, Name, Status__c, Tag_Number__c, Serial_plate_of_asset__c, Attachment__c
				FROM Equipment_Missing_Form__c
				WHERE Id = :stdCtrl.getId()
		];

		List<Attachment> attList = [SELECT Id, Name FROM Attachment WHERE ParentId = :addingForm.Id];
		System.assert(attList.size() == 2);

		PageReference editPage = Page.EquipmentMissingFormEdit;
		Test.setCurrentPage(editPage);
		editPage.getParameters().clear();
		editPage.getParameters().put('id', addingForm.Id);
		editPage.getParameters().put('locId', null);
		editPage.getParameters().put('retURL', wellLocation.Id);

		stdCtrl = new ApexPages.StandardController(addingForm);
		EquipmentMissingFormControllerX addingFormEditCtrl = new EquipmentMissingFormControllerX(stdCtrl);
		addingForm = addingFormEditCtrl.form;
		addingFormEditCtrl.serialPlate = attList[0];
		addingFormEditCtrl.attachment = attList[1];
		System.assertEquals(addingForm.Manufacturer__c, 'TANK');
		//  System.assert(addingFormEditCtrl.attachment.Id != null);

		addingFormEditCtrl.attId = attList[0].Id;
		addingFormEditCtrl.DeletePhoto();
		addingFormEditCtrl.form.Comments__c = 'delete attachment';
		addingFormEditCtrl.save();

		//close the Request
		addingFormEditCtrl.CloseRequest();

		addingForm = [SELECT Id, Status__c FROM Equipment_Missing_Form__c WHERE Id = :addingForm.Id];
		System.assertEquals(addingForm.Status__c, EquipmentUtilities.REQUEST_STATUS_PROCESSED);

	}
	@IsTest
	static void testAddEquipmentFormEvent() {

		createSampleData();
		Location__c wellLocation = LocationTestData.createLocation('Location for testing', route.Id, field.Id);
		insert wellLocation;

		Well_Event__c wellEvent = LocationTestData.createEvent('Test Well Event', wellLocation.Id);
		insert wellEvent;

		//test create a new Add Equipment Form
		PageReference pageRef = Page.EquipmentMissingFormEdit;
		Test.setCurrentPage(pageRef);
		pageRef.getParameters().put('eventId', wellEvent.Id);

		Equipment_Missing_Form__c addingForm = new Equipment_Missing_Form__c();
		ApexPages.StandardController stdCtrl = new ApexPages.StandardController(addingForm);
		EquipmentMissingFormControllerX addingFormCtrl = new EquipmentMissingFormControllerX(stdCtrl);
		addingForm = addingFormCtrl.form;

		System.assertEquals(addingForm.Well_Event__c, wellEvent.Id);
		System.assertEquals(addingForm.Status__c, 'Open');
		System.assertEquals(addingForm.Equipment_Status__c, 'Missing');

		System.assert(addingFormCtrl.attachment.Id == null);
		System.assert(addingFormCtrl.serialPlate.Id == null);
		//test validation error: Manufacturer is required
		try {
			addingFormCtrl.save();
		} catch (Exception e) {
			System.assert(false, 'You must enter a value');
		}
		//Serial No is required
		try {
			addingForm.Manufacturer__c = 'TANK';
			addingFormCtrl.save();
		} catch (Exception e) {
			System.assert(false, 'You must enter a value');
		}
		//Serial Plate of Asset is required
		try {
			addingForm.Manufacturer_Serial_No__c = '121342';
			addingFormCtrl.serialPlate.Body = null;
			addingFormCtrl.save();
		} catch (Exception e) {
			System.assert(false, 'You must attach a file');
		}
		//Well event is required
		try {
			addingForm.Well_Event__c = null;
			addingFormCtrl.save();
		} catch (Exception e) {
			System.assert(false, 'Please go to a Well Location / Facility / Well Event / System or Sub-System detail page and click the "Add Equipment Form" button on the Equipment related list.');
		}
		addingForm.Manufacturer__c = 'TANK';
		addingForm.Manufacturer_Serial_No__c = '123142';
		addingForm.Status__c = 'Open';
		addingForm.Equipment_Status__c = 'Missing';
		addingForm.Well_Event__c = wellEvent.Id;
		addingForm.Description__c = 'Description';
		addingForm.Model_Number__c = 'Test';
		addingFormCtrl.serialPlate.Name = 'upload attachment';
		addingFormCtrl.serialPlate.Body = Blob.valueOf('testing testing');
		addingFormCtrl.attachment.Name = 'upload attachment 1';
		addingFormCtrl.attachment.Body = Blob.valueOf('testing');

		addingFormCtrl.save();
		//the record is save successfull
		System.assert(stdCtrl.getId() != null);

		//test edit Data Update form
		addingForm = [
				SELECT Comments__c, Id, Equipment_Status__c,
						Manufacturer__c, Manufacturer_Serial_No__c, Location__c,
						Model_Number__c, Name, Status__c, Tag_Number__c, Serial_plate_of_asset__c, Attachment__c
				FROM Equipment_Missing_Form__c
				WHERE Id = :stdCtrl.getId()
		];

		List<Attachment> attList = [SELECT Id, Name FROM Attachment WHERE ParentId = :addingForm.Id];
		System.assert(attList.size() == 2);

		PageReference editPage = Page.EquipmentMissingFormEdit;
		Test.setCurrentPage(editPage);
		editPage.getParameters().clear();
		editPage.getParameters().put('id', addingForm.Id);
		editPage.getParameters().put('eventId', null);
		editPage.getParameters().put('retURL', wellEvent.Id);

		stdCtrl = new ApexPages.StandardController(addingForm);
		EquipmentMissingFormControllerX addingFormEditCtrl = new EquipmentMissingFormControllerX(stdCtrl);
		addingForm = addingFormEditCtrl.form;
		addingFormEditCtrl.serialPlate = attList[0];
		addingFormEditCtrl.attachment = attList[1];
		System.assertEquals(addingForm.Manufacturer__c, 'TANK');

		addingFormEditCtrl.attId = attList[0].Id;
		addingFormEditCtrl.DeletePhoto();
		addingFormEditCtrl.form.Comments__c = 'delete attachment';
		addingFormEditCtrl.save();

		//close the Request
		addingFormEditCtrl.CloseRequest();

		addingForm = [SELECT Id, Status__c FROM Equipment_Missing_Form__c WHERE Id = :addingForm.Id];
		System.assertEquals(addingForm.Status__c, EquipmentUtilities.REQUEST_STATUS_PROCESSED);

	}
	@IsTest
	static void testAddEquipmentFormSystem() {

		createSampleData();

		System__c sys = LocationTestData.createSystem('Test System');

		//test create a new Add Equipment Form
		PageReference pageRef = Page.EquipmentMissingFormEdit;
		Test.setCurrentPage(pageRef);
		pageRef.getParameters().put('sysId', sys.Id);

		Equipment_Missing_Form__c addingForm = new Equipment_Missing_Form__c();
		ApexPages.StandardController stdCtrl = new ApexPages.StandardController(addingForm);
		EquipmentMissingFormControllerX addingFormCtrl = new EquipmentMissingFormControllerX(stdCtrl);
		addingForm = addingFormCtrl.form;

		System.assertEquals(addingForm.System__c, sys.Id);
		System.assertEquals(addingForm.Status__c, 'Open');
		System.assertEquals(addingForm.Equipment_Status__c, 'Missing');

		System.assert(addingFormCtrl.attachment.Id == null);
		System.assert(addingFormCtrl.serialPlate.Id == null);
		//test validation error: Manufacturer is required
		try {
			addingFormCtrl.save();
		} catch (Exception e) {
			System.assert(false, 'You must enter a value');
		}
		//Serial No is required
		try {
			addingForm.Manufacturer__c = 'TANK';
			addingFormCtrl.save();
		} catch (Exception e) {
			System.assert(false, 'You must enter a value');
		}
		//Serial Plate of Asset is required
		try {
			addingForm.Manufacturer_Serial_No__c = '121342';
			addingFormCtrl.serialPlate.Body = null;
			addingFormCtrl.save();
		} catch (Exception e) {
			System.assert(false, 'You must attach a file');
		}
		//Well event is required
		try {
			addingForm.System__c = null;
			addingFormCtrl.save();
		} catch (Exception e) {
			System.assert(false, 'Please go to a Well Location / Facility / Well Event / System or Sub-System detail page and click the "Add Equipment Form" button on the Equipment related list.');
		}
		addingForm.Manufacturer__c = 'TANK';
		addingForm.Manufacturer_Serial_No__c = '123142';
		addingForm.Status__c = 'Open';
		addingForm.Equipment_Status__c = 'Missing';
		addingForm.System__c = sys.Id;
		addingForm.Description__c = 'Description';
		addingForm.Model_Number__c = 'Test';
		addingFormCtrl.serialPlate.Name = 'upload attachment';
		addingFormCtrl.serialPlate.Body = Blob.valueOf('testing testing');
		addingFormCtrl.attachment.Name = 'upload attachment 1';
		addingFormCtrl.attachment.Body = Blob.valueOf('testing');

		addingFormCtrl.save();
		//the record is save successfull
		System.assert(stdCtrl.getId() != null);

		//test edit Data Update form
		addingForm = [
				SELECT Comments__c, Id, Equipment_Status__c,
						Manufacturer__c, Manufacturer_Serial_No__c, Location__c,
						Model_Number__c, Name, Status__c, Tag_Number__c, Serial_plate_of_asset__c, Attachment__c
				FROM Equipment_Missing_Form__c
				WHERE Id = :stdCtrl.getId()
		];

		List<Attachment> attList = [SELECT Id, Name FROM Attachment WHERE ParentId = :addingForm.Id];
		System.assert(attList.size() == 2);

		PageReference editPage = Page.EquipmentMissingFormEdit;
		Test.setCurrentPage(editPage);
		editPage.getParameters().clear();
		editPage.getParameters().put('id', addingForm.Id);
		editPage.getParameters().put('sysId', null);
		editPage.getParameters().put('retURL', sys.Id);

		stdCtrl = new ApexPages.StandardController(addingForm);
		EquipmentMissingFormControllerX addingFormEditCtrl = new EquipmentMissingFormControllerX(stdCtrl);
		addingForm = addingFormEditCtrl.form;
		addingFormEditCtrl.serialPlate = attList[0];
		addingFormEditCtrl.attachment = attList[1];
		System.assertEquals(addingForm.Manufacturer__c, 'TANK');

		addingFormEditCtrl.attId = attList[0].Id;
		addingFormEditCtrl.DeletePhoto();
		addingFormEditCtrl.form.Comments__c = 'delete attachment';
		addingFormEditCtrl.save();

		//close the Request
		addingFormEditCtrl.CloseRequest();

		addingForm = [SELECT Id, Status__c FROM Equipment_Missing_Form__c WHERE Id = :addingForm.Id];
		System.assertEquals(addingForm.Status__c, EquipmentUtilities.REQUEST_STATUS_PROCESSED);

	}
	@IsTest
	static void testAddEquipmentFormSubSystem() {

		createSampleData();

		Sub_System__c subSys = LocationTestData.createSubSystem('Test SubSystem');

		//test create a new Add Equipment Form
		PageReference pageRef = Page.EquipmentMissingFormEdit;
		Test.setCurrentPage(pageRef);
		pageRef.getParameters().put('subSysId', subSys.Id);

		Equipment_Missing_Form__c addingForm = new Equipment_Missing_Form__c();
		ApexPages.StandardController stdCtrl = new ApexPages.StandardController(addingForm);
		EquipmentMissingFormControllerX addingFormCtrl = new EquipmentMissingFormControllerX(stdCtrl);
		addingForm = addingFormCtrl.form;

		System.assertEquals(addingForm.Sub_System__c, subSys.Id);
		System.assertEquals(addingForm.Status__c, 'Open');
		System.assertEquals(addingForm.Equipment_Status__c, 'Missing');

		System.assert(addingFormCtrl.attachment.Id == null);
		System.assert(addingFormCtrl.serialPlate.Id == null);
		//test validation error: Manufacturer is required
		try {
			addingFormCtrl.save();
		} catch (Exception e) {
			System.assert(false, 'You must enter a value');
		}
		//Serial No is required
		try {
			addingForm.Manufacturer__c = 'TANK';
			addingFormCtrl.save();
		} catch (Exception e) {
			System.assert(false, 'You must enter a value');
		}
		//Serial Plate of Asset is required
		try {
			addingForm.Manufacturer_Serial_No__c = '121342';
			addingFormCtrl.serialPlate.Body = null;
			addingFormCtrl.save();
		} catch (Exception e) {
			System.assert(false, 'You must attach a file');
		}
		//Well event is required
		try {
			addingForm.Sub_System__c = null;
			addingFormCtrl.save();
		} catch (Exception e) {
			System.assert(false, 'Please go to a Well Location / Facility / Well Event / System or Sub-System detail page and click the "Add Equipment Form" button on the Equipment related list.');
		}
		addingForm.Manufacturer__c = 'TANK';
		addingForm.Manufacturer_Serial_No__c = '123142';
		addingForm.Status__c = 'Open';
		addingForm.Description__c = 'Description';
		addingForm.Model_Number__c = 'Test';
		addingForm.Equipment_Status__c = 'Missing';
		addingForm.Sub_System__c = subSys.Id;
		addingFormCtrl.serialPlate.Name = 'upload attachment';
		addingFormCtrl.serialPlate.Body = Blob.valueOf('testing testing');
		addingFormCtrl.attachment.Name = 'upload attachment 1';
		addingFormCtrl.attachment.Body = Blob.valueOf('testing');

		addingFormCtrl.save();
		//the record is save successfull
		System.assert(stdCtrl.getId() != null);

		//test edit Data Update form
		addingForm = [
				SELECT Comments__c, Id, Equipment_Status__c,
						Manufacturer__c, Manufacturer_Serial_No__c, Location__c,
						Model_Number__c, Name, Status__c, Tag_Number__c, Serial_plate_of_asset__c, Attachment__c
				FROM Equipment_Missing_Form__c
				WHERE Id = :stdCtrl.getId()
		];

		List<Attachment> attList = [SELECT Id, Name FROM Attachment WHERE ParentId = :addingForm.Id];
		System.assert(attList.size() == 2);

		PageReference editPage = Page.EquipmentMissingFormEdit;
		Test.setCurrentPage(editPage);
		editPage.getParameters().clear();
		editPage.getParameters().put('id', addingForm.Id);
		editPage.getParameters().put('subSysId', null);
		editPage.getParameters().put('retURL', subSys.Id);

		stdCtrl = new ApexPages.StandardController(addingForm);
		EquipmentMissingFormControllerX addingFormEditCtrl = new EquipmentMissingFormControllerX(stdCtrl);
		addingForm = addingFormEditCtrl.form;
		addingFormEditCtrl.serialPlate = attList[0];
		addingFormEditCtrl.attachment = attList[1];
		System.assertEquals(addingForm.Manufacturer__c, 'TANK');

		addingFormEditCtrl.attId = attList[0].Id;
		addingFormEditCtrl.DeletePhoto();
		addingFormEditCtrl.form.Comments__c = 'delete attachment';
		addingFormEditCtrl.save();

		//close the Request
		addingFormEditCtrl.CloseRequest();

		addingForm = [SELECT Id, Status__c FROM Equipment_Missing_Form__c WHERE Id = :addingForm.Id];
		System.assertEquals(addingForm.Status__c, EquipmentUtilities.REQUEST_STATUS_PROCESSED);

	}
	@IsTest
	static void testAddEquipmentFormFEL() {

		createSampleData();

		Functional_Equipment_Level__c fel = LocationTestData.createFEL('Test FEL');

		//test create a new Add Equipment Form
		PageReference pageRef = Page.EquipmentMissingFormEdit;
		Test.setCurrentPage(pageRef);
		pageRef.getParameters().put('felId', fel.Id);

		Equipment_Missing_Form__c addingForm = new Equipment_Missing_Form__c();
		ApexPages.StandardController stdCtrl = new ApexPages.StandardController(addingForm);
		EquipmentMissingFormControllerX addingFormCtrl = new EquipmentMissingFormControllerX(stdCtrl);
		addingForm = addingFormCtrl.form;

		System.assertEquals(addingForm.Functional_Equipment_Level__c, fel.Id);
		System.assertEquals(addingForm.Status__c, 'Open');
		System.assertEquals(addingForm.Equipment_Status__c, 'Missing');

		System.assert(addingFormCtrl.attachment.Id == null);
		System.assert(addingFormCtrl.serialPlate.Id == null);
		//test validation error: Manufacturer is required
		try {
			addingFormCtrl.save();
		} catch (Exception e) {
			System.assert(false, 'You must enter a value');
		}
		//Serial No is required
		try {
			addingForm.Manufacturer__c = 'TANK';
			addingFormCtrl.save();
		} catch (Exception e) {
			System.assert(false, 'You must enter a value');
		}
		//Serial Plate of Asset is required
		try {
			addingForm.Manufacturer_Serial_No__c = '121342';
			addingForm.Manufacturer__c = 'TANK';
			addingFormCtrl.serialPlate.Body = null;
			addingForm.Description__c = 'Description';
			addingForm.Model_Number__c = 'Test';
			addingFormCtrl.save();
		} catch (Exception e) {
			System.assert(false, 'You must attach a file');
		}

		try {
			addingForm.Functional_Equipment_Level__c = null;
			addingFormCtrl.save();
		} catch (Exception e) {
			System.assert(false, 'Please go to a Well Location / Facility / Well Event / System or Sub-System detail page and click the "Add Equipment Form" button on the Equipment related list.');
		}
		addingForm.Manufacturer__c = 'TANK';
		addingForm.Manufacturer_Serial_No__c = '123142';
		addingForm.Status__c = 'Open';
		addingForm.Equipment_Status__c = 'Missing';
		addingForm.Functional_Equipment_Level__c = fel.Id;
		addingForm.Description__c = 'Description';
		addingForm.Model_Number__c = 'Test';
		addingFormCtrl.serialPlate.Name = 'upload attachment';
		addingFormCtrl.serialPlate.Body = Blob.valueOf('testing testing');
		addingFormCtrl.attachment.Name = 'upload attachment 1';
		addingFormCtrl.attachment.Body = Blob.valueOf('testing');

		addingFormCtrl.save();
		//the record is save successfull
		System.assert(stdCtrl.getId() != null);

		//test edit Data Update form
		addingForm = [
				SELECT Comments__c, Id, Equipment_Status__c,
						Manufacturer__c, Manufacturer_Serial_No__c, Location__c,
						Model_Number__c, Name, Status__c, Tag_Number__c, Serial_plate_of_asset__c, Attachment__c
				FROM Equipment_Missing_Form__c
				WHERE Id = :stdCtrl.getId()
		];

		List<Attachment> attList = [SELECT Id, Name FROM Attachment WHERE ParentId = :addingForm.Id];
		System.assert(attList.size() == 2);

		PageReference editPage = Page.EquipmentMissingFormEdit;
		Test.setCurrentPage(editPage);
		editPage.getParameters().clear();
		editPage.getParameters().put('id', addingForm.Id);
		editPage.getParameters().put('felId', null);
		editPage.getParameters().put('retURL', fel.Id);

		stdCtrl = new ApexPages.StandardController(addingForm);
		EquipmentMissingFormControllerX addingFormEditCtrl = new EquipmentMissingFormControllerX(stdCtrl);
		addingForm = addingFormEditCtrl.form;
		addingFormEditCtrl.serialPlate = attList[0];
		addingFormEditCtrl.attachment = attList[1];
		System.assertEquals(addingForm.Manufacturer__c, 'TANK');

		addingFormEditCtrl.attId = attList[0].Id;
		addingFormEditCtrl.DeletePhoto();
		addingFormEditCtrl.form.Comments__c = 'delete attachment';
		addingFormEditCtrl.save();

		//close the Request
		addingFormEditCtrl.CloseRequest();

		addingForm = [SELECT Id, Status__c FROM Equipment_Missing_Form__c WHERE Id = :addingForm.Id];
		System.assertEquals(addingForm.Status__c, EquipmentUtilities.REQUEST_STATUS_PROCESSED);

	}
	@IsTest
	static void testAddEquipmentFormYARD() {

		createSampleData();

		Yard__c yard = LocationTestData.createYard('Test Yard');

		//test create a new Add Equipment Form
		PageReference pageRef = Page.EquipmentMissingFormEdit;
		Test.setCurrentPage(pageRef);
		pageRef.getParameters().put('yardId', yard.Id);

		Equipment_Missing_Form__c addingForm = new Equipment_Missing_Form__c();
		ApexPages.StandardController stdCtrl = new ApexPages.StandardController(addingForm);
		EquipmentMissingFormControllerX addingFormCtrl = new EquipmentMissingFormControllerX(stdCtrl);
		addingForm = addingFormCtrl.form;

		System.assertEquals(addingForm.Yard__c, yard.Id);
		System.assertEquals(addingForm.Status__c, 'Open');
		System.assertEquals(addingForm.Equipment_Status__c, 'Missing');

		System.assert(addingFormCtrl.attachment.Id == null);
		System.assert(addingFormCtrl.serialPlate.Id == null);
		System.assertEquals(addingFormCtrl.isEmptyFloc, false);
		//test validation error: Manufacturer is required
		try {
			addingFormCtrl.save();
		} catch (Exception e) {
			System.assert(false, 'You must enter a value');
		}
		//Serial No is required
		try {
			addingForm.Manufacturer__c = 'TANK';
			addingFormCtrl.save();
		} catch (Exception e) {
			System.assert(false, 'You must enter a value');
		}
		//Serial Plate of Asset is required
		try {
			addingForm.Manufacturer_Serial_No__c = '121342';
			addingFormCtrl.serialPlate.Body = null;
			addingFormCtrl.save();
		} catch (Exception e) {
			System.assert(false, 'You must attach a file');
		}

		try {
			addingForm.Yard__c = null;
			addingFormCtrl.save();
			System.assertEquals(addingFormCtrl.isEmptyFloc, true);
		} catch (Exception e) {
			System.assert(false, 'Please go to a Well Location / Facility / Well Event / System or Sub-System detail page and click the "Add Equipment Form" button on the Equipment related list.');
		}
		addingForm.Manufacturer__c = 'TANK';
		addingForm.Manufacturer_Serial_No__c = '123142';
		addingForm.Status__c = 'Open';
		addingForm.Equipment_Status__c = 'Missing';
		addingForm.Yard__c = yard.Id;
		addingForm.Description__c = 'Description';
		addingForm.Model_Number__c = 'Test';
		addingFormCtrl.serialPlate.Name = 'upload attachment';
		addingFormCtrl.serialPlate.Body = Blob.valueOf('testing testing');
		addingFormCtrl.attachment.Name = 'upload attachment 1';
		addingFormCtrl.attachment.Body = Blob.valueOf('testing');

		addingFormCtrl.save();
		//the record is save successfull
		System.assert(stdCtrl.getId() != null);

		//test edit Data Update form
		addingForm = [
				SELECT Comments__c, Id, Equipment_Status__c,
						Manufacturer__c, Manufacturer_Serial_No__c, Location__c,
						Model_Number__c, Name, Status__c, Tag_Number__c, Serial_plate_of_asset__c, Attachment__c
				FROM Equipment_Missing_Form__c
				WHERE Id = :stdCtrl.getId()
		];

		List<Attachment> attList = [SELECT Id, Name FROM Attachment WHERE ParentId = :addingForm.Id];
		System.assert(attList.size() == 2);

		PageReference editPage = Page.EquipmentMissingFormEdit;
		Test.setCurrentPage(editPage);
		editPage.getParameters().clear();
		editPage.getParameters().put('id', addingForm.Id);
		editPage.getParameters().put('yardId', null);
		editPage.getParameters().put('retURL', yard.Id);

		stdCtrl = new ApexPages.StandardController(addingForm);
		EquipmentMissingFormControllerX addingFormEditCtrl = new EquipmentMissingFormControllerX(stdCtrl);
		addingForm = addingFormEditCtrl.form;
		addingFormEditCtrl.serialPlate = attList[0];
		addingFormEditCtrl.attachment = attList[1];
		System.assertEquals(addingForm.Manufacturer__c, 'TANK');

		addingFormEditCtrl.attId = attList[0].Id;
		addingFormEditCtrl.DeletePhoto();
		addingFormEditCtrl.form.Comments__c = 'delete attachment';
		addingFormEditCtrl.save();

		//close the Request
		addingFormEditCtrl.CloseRequest();

		addingForm = [SELECT Id, Status__c FROM Equipment_Missing_Form__c WHERE Id = :addingForm.Id];
		System.assertEquals(addingForm.Status__c, EquipmentUtilities.REQUEST_STATUS_PROCESSED);

	}
	@IsTest
	static void testAddEquipmentFormFacility() {

		createSampleData();

		Facility__c facility = FacilityTestData.createFacility('Test Facility', route.Id, field.Id);
		insert facility;

		//test create a new Add Equipment Form
		PageReference pageRef = Page.EquipmentMissingFormEdit;
		Test.setCurrentPage(pageRef);
		pageRef.getParameters().put('facId', facility.Id);

		Equipment_Missing_Form__c addingForm = new Equipment_Missing_Form__c();
		ApexPages.StandardController stdCtrl = new ApexPages.StandardController(addingForm);
		EquipmentMissingFormControllerX addingFormCtrl = new EquipmentMissingFormControllerX(stdCtrl);
		addingForm = addingFormCtrl.form;

		System.assertEquals(addingForm.Facility__c, facility.Id);
		System.assertEquals(addingForm.Status__c, 'Open');
		System.assertEquals(addingForm.Equipment_Status__c, 'Missing');

		System.assert(addingFormCtrl.attachment.Id == null);
		System.assert(addingFormCtrl.serialPlate.Id == null);
		//test validation error: Manufacturer is required
		try {
			addingFormCtrl.save();
		} catch (Exception e) {
			System.assert(false, 'You must enter a value');
		}
		//Serial No is required
		try {
			addingForm.Manufacturer__c = 'TANK';
			addingFormCtrl.save();
		} catch (Exception e) {
			System.assert(false, 'You must enter a value');
		}
		//Serial Plate of Asset is required
		try {
			addingForm.Manufacturer_Serial_No__c = '121342';
			addingFormCtrl.serialPlate.Body = null;
			addingFormCtrl.save();
		} catch (Exception e) {
			System.assert(false, 'You must attach a file');
		}
		//Well event is required
		try {
			addingForm.Facility__c = null;
			addingFormCtrl.save();
		} catch (Exception e) {
			System.assert(false, 'Please go to a Well Location detail page and click the "Add Equipment Form" button on the Equipment related list.');
		}
		addingForm.Manufacturer__c = 'TANK';
		addingForm.Manufacturer_Serial_No__c = '123142';
		addingForm.Status__c = 'Open';
		addingForm.Equipment_Status__c = 'Missing';
		addingForm.Facility__c = facility.Id;
		addingForm.Description__c = 'Description';
		addingForm.Model_Number__c = 'Test';
		addingFormCtrl.serialPlate.Name = 'upload attachment';
		addingFormCtrl.serialPlate.Body = Blob.valueOf('testing testing');
		addingFormCtrl.attachment.Name = 'upload attachment 1';
		addingFormCtrl.attachment.Body = Blob.valueOf('testing');

		addingFormCtrl.save();
		//the record is save successfull
		System.assert(stdCtrl.getId() != null);

		//test edit Data Update form
		addingForm = [
				SELECT Comments__c, Id, Equipment_Status__c,
						Manufacturer__c, Manufacturer_Serial_No__c, Location__c,
						Model_Number__c, Name, Status__c, Tag_Number__c, Serial_plate_of_asset__c, Attachment__c
				FROM Equipment_Missing_Form__c
				WHERE Id = :stdCtrl.getId()
		];

		List<Attachment> attList = [SELECT Id, Name FROM Attachment WHERE ParentId = :addingForm.Id];
		System.assert(attList.size() == 2);

		PageReference editPage = Page.EquipmentMissingFormEdit;
		Test.setCurrentPage(editPage);
		editPage.getParameters().clear();
		editPage.getParameters().put('id', addingForm.Id);
		editPage.getParameters().put('facId', null);
		editPage.getParameters().put('retURL', facility.Id);

		stdCtrl = new ApexPages.StandardController(addingForm);
		EquipmentMissingFormControllerX addingFormEditCtrl = new EquipmentMissingFormControllerX(stdCtrl);
		addingForm = addingFormEditCtrl.form;
		addingFormEditCtrl.serialPlate = attList[0];
		addingFormEditCtrl.attachment = attList[1];
		System.assertEquals(addingForm.Manufacturer__c, 'TANK');

		addingFormEditCtrl.attId = attList[0].Id;
		addingFormEditCtrl.DeletePhoto();
		addingFormEditCtrl.form.Comments__c = 'delete attachment';
		addingFormEditCtrl.save();

		//close the Request
		addingFormEditCtrl.CloseRequest();

		addingForm = [SELECT Id, Status__c FROM Equipment_Missing_Form__c WHERE Id = :addingForm.Id];
		System.assertEquals(addingForm.Status__c, EquipmentUtilities.REQUEST_STATUS_PROCESSED);

	}
	@IsTest
	static void testAddEquipmentBulkClose() {

		User sapSupportLeadUser = EquipmentTestData.createUser('SAP Support - Lead', 'Standard HOG - General User', 'SAP_Support_LeadUser@test.com');

		System.runAs(sapSupportLeadUser) {

			createSampleData();
			Location__c wellLocation = LocationTestData.createLocation('Location for testing', route.Id, field.Id);
			insert wellLocation;

			//create bulk of "Open" Add Equipment form
			List<Equipment_Missing_Form__c> formList = new List<Equipment_Missing_Form__c>();
			for (Integer i = 0; i < 3; i++) {
				Equipment_Missing_Form__c form = new Equipment_Missing_Form__c();
				form.Location__c = wellLocation.Id;
				form.Status__c = 'Open';
				form.Equipment_Status__c = 'Missing';
				form.Manufacturer__c = 'SAMSUNG';
				form.Manufacturer_Serial_No__c = '46464';
				form.Serial_plate_of_asset__c = '0024253647442';
				formList.add(form);
			}
			insert formList;


			formList = [
					SELECT Comments__c, Id, Equipment_Status__c, Location__c,
							Manufacturer__c, Manufacturer_Serial_No__c,
							Model_Number__c, Name, Status__c, Tag_Number__c, Serial_plate_of_asset__c, Attachment__c,
							Well_Event__c, System__c, Sub_System__c, Functional_Equipment_Level__c, Yard__c, Facility__c
					FROM Equipment_Missing_Form__c
					WHERE Location__c = :wellLocation.Id
			];


			ApexPages.StandardSetController stdcon = new ApexPages.StandardSetController(new List<Equipment_Missing_Form__c>());
			stdcon.setSelected(new List<Equipment_Missing_Form__c>());
			EquipmentMissingFormBulkCloseControllerX setCtrl;
			//display error when no Form is selected
			try {
				setCtrl = new EquipmentMissingFormBulkCloseControllerX(stdcon);
			} catch (Exception e) {
				System.assert(false, 'Please select at least one Add Equipment Form');
			}
			System.debug(stdcon.getSelected().size() == 0);

			stdcon = new ApexPages.StandardSetController(formList);
			stdcon.setSelected(formList);
			setCtrl = new EquipmentMissingFormBulkCloseControllerX(stdcon);

			System.assertEquals(1, setCtrl.CurrentIndex);
			System.assertNotEquals(null, setCtrl.CurrentForm);
			System.assertEquals(3, setCtrl.selectedList.size());


			Equipment_Missing_Form__c CurrentForm = setCtrl.CurrentForm;
			Attachment att = new Attachment();
			att.Name = 'test attachment';
			att.Body = Blob.valueOf('file content');
			att.ParentId = CurrentForm.Id;
			insert att;

			Attachment att2 = new Attachment();
			att2.Name = 'test attachment';
			att2.Body = Blob.valueOf('file content');
			att2.ParentId = CurrentForm.Id;
			insert att2;

			CurrentForm.Attachment__c = att2.Id;
			CurrentForm.Serial_plate_of_asset__c = att.Id;
			update CurrentForm;

			System.assert(setCtrl.serialPlate.Id != null);
			System.assert(setCtrl.attachment.Id != null);

			Equipment_Missing_Form__c Form2 = setCtrl.selectedList[1];
			Equipment_Missing_Form__c Form3 = setCtrl.selectedList[2];

			System.assertEquals(false, setCtrl.getHasPreviousForm());
			System.assertEquals(true, setCtrl.getHasNextForm());

			setCtrl.NextForm();
			setCtrl.serialPlate = null;
			setCtrl.attachment = null;
			System.assertEquals(2, setCtrl.CurrentIndex);
			System.assertEquals(Form2, setCtrl.CurrentForm);
			System.assertEquals(true, setCtrl.getHasPreviousForm());
			System.assertEquals(true, setCtrl.getHasNextForm());

			setCtrl.NextForm();
			System.assertEquals(3, setCtrl.CurrentIndex);
			System.assertEquals(Form3, setCtrl.CurrentForm);
			System.assertEquals(true, setCtrl.getHasPreviousForm());
			System.assertEquals(false, setCtrl.getHasNextForm());

			//lets try to go over the last form
			setCtrl.NextForm();
			System.assertEquals(3, setCtrl.CurrentIndex); //still 3
			System.assertEquals(Form3, setCtrl.CurrentForm);
			System.assertEquals(true, setCtrl.getHasPreviousForm());
			System.assertEquals(false, setCtrl.getHasNextForm());

			setCtrl.PreviousForm();
			System.assertEquals(2, setCtrl.CurrentIndex);
			System.assertEquals(Form2, setCtrl.CurrentForm);
			System.assertEquals(true, setCtrl.getHasPreviousForm());
			System.assertEquals(true, setCtrl.getHasNextForm());

			setCtrl.CloseForm();
			Form2 = [SELECT Id, Status__c FROM Equipment_Missing_Form__c WHERE Id = :Form2.Id];
			System.assertEquals(Form2.Status__c, EquipmentUtilities.REQUEST_STATUS_PROCESSED);

		}
	}
	@IsTest
	static void testAddEquipmentBulkCloseNonSAPSupportuser() {

		//user is not SAP Support Lead - will fail
		User HOGUser = EquipmentTestData.createUser('Heavy Oil & Gas', 'Standard HOG - General User', 'SAP_Support_LeadUser@test.com');

		System.runAs(HOGUser) {
			createSampleData();
			Location__c wellLocation = LocationTestData.createLocation('Location for testing', route.Id, field.Id);
			insert wellLocation;

			//create bulk of "Open" Add Equipment form
			List<Equipment_Missing_Form__c> formList = new List<Equipment_Missing_Form__c>();
			for (Integer i = 0; i < 3; i++) {
				Equipment_Missing_Form__c form = new Equipment_Missing_Form__c();
				form.Location__c = wellLocation.Id;
				form.Status__c = 'Open';
				form.Equipment_Status__c = 'Missing';
				form.Manufacturer__c = 'SAMSUNG';
				form.Manufacturer_Serial_No__c = '46464';
				form.Serial_plate_of_asset__c = '0024253647442';
				formList.add(form);
			}
			insert formList;


			formList = [
					SELECT Comments__c, Id, Equipment_Status__c, Location__c,
							Manufacturer__c, Manufacturer_Serial_No__c,
							Model_Number__c, Name, Status__c, Tag_Number__c, Serial_plate_of_asset__c, Attachment__c,
							Well_Event__c, System__c, Sub_System__c, Functional_Equipment_Level__c, Yard__c, Facility__c
					FROM Equipment_Missing_Form__c
					WHERE Location__c = :wellLocation.Id
			];


			ApexPages.StandardSetController stdcon = new ApexPages.StandardSetController(new List<Equipment_Missing_Form__c>());
			stdcon.setSelected(new List<Equipment_Missing_Form__c>());
			EquipmentMissingFormBulkCloseControllerX setCtrl;
			//display error when no Form is selected
			try {
				setCtrl = new EquipmentMissingFormBulkCloseControllerX(stdcon);
			} catch (Exception e) {
				System.assert(false, 'Please select at least one Add Equipment Form');
			}

			stdcon = new ApexPages.StandardSetController(formList);
			stdcon.setSelected(formList);
			setCtrl = new EquipmentMissingFormBulkCloseControllerX(stdcon);

			List<Apexpages.Message> msgs = ApexPages.getMessages();
			Boolean b = false;

			for (Apexpages.Message msg : msgs) {

				if (msg.getDetail().contains('Only SAP Support Lead, HOG - Administrator or System Administrator can process.')) {

					b = true;
				}
			}

			System.assert(b);   //Assert the Page Message was Properly Displayed

		}
	}

	@IsTest
	static void addEquipmentRejectedTest() {

		createSampleData();

		Location__c loc = LocationTestData.createLocation('LocationSource', route.Id, field.Id);
		insert loc;

		Account acc1 = AccountTestData.createAccount('MojAcc', null);
		insert acc1;

		List<User> user = [SELECT Id FROM User LIMIT 2];
		Contact cnt1 = EquipmentTestData.createContact(acc1.Id, 'Mysko', 'Chinchilla', user[0].Id, 'mysko@chinchilla.ocm');
		insert cnt1;
		Contact cnt2 = EquipmentTestData.createContact(acc1.Id, 'Howard', 'TheDuck', user[1].Id);
		insert cnt2;
		HOG_Planner_Group_Notification_Type__c leadMail = new HOG_Planner_Group_Notification_Type__c();
		leadMail.HOG_Planner_Group__c = plannerGroup.Id;
		leadMail.Contact__c = cnt1.Id;
		leadMail.Role_Type__c = EquipmentUtilities.ROLE_TRADEMAN_LEAD;
		insert leadMail;
		HOG_Planner_Group_Notification_Type__c leadMail2 = new HOG_Planner_Group_Notification_Type__c();
		leadMail2.HOG_Planner_Group__c = plannerGroup.Id;
		leadMail2.Contact__c = cnt2.Id;
		leadMail2.Role_Type__c = EquipmentUtilities.ROLE_TRADEMAN_LEAD;
		insert leadMail2;

		Equipment_Missing_Form__c addingForm = new Equipment_Missing_Form__c();
		ApexPages.StandardController stdCtrl = new ApexPages.StandardController(addingForm);
		EquipmentMissingFormControllerX addingFormCtrl = new EquipmentMissingFormControllerX(stdCtrl);
		addingForm = addingFormCtrl.form;
		addingForm.Manufacturer__c = 'TANK';
		addingForm.Manufacturer_Serial_No__c = '123142';
		addingForm.Status__c = EquipmentUtilities.REQUEST_STATUS_OPEN;
		addingForm.Equipment_Status__c = 'Missing';
		addingForm.Location__c = loc.Id;
		addingForm.Location__r = loc;
		addingForm.Description__c = 'Description';
		addingForm.Model_Number__c = 'Test';
		addingForm.CreatedById = user[0].Id;
		addingFormCtrl.serialPlate.Name = 'upload attachment';
		addingFormCtrl.serialPlate.Body = Blob.valueOf('testing testing');
		addingFormCtrl.attachment.Name = 'upload attachment 1';
		addingFormCtrl.attachment.Body = Blob.valueOf('testing');
		insert addingForm;

		Test.startTest();
		addingForm.Location__r.Planner_Group__c = '100';
		addingFormCtrl.rejectAndNotify();
		System.assert(addingFormCtrl.displayPopup, 'Popup window haven\'t been shown');
		addingFormCtrl.saveOnPopup();

		Integer invocations = Limits.getEmailInvocations();
		System.assertEquals(1, invocations, 'Email haven\'t been sent.');
		Boolean rejectedMsgFound = false;
		for (ApexPages.Message msg : ApexPages.getMessages()) {
			if (msg.getDetail().contains('REJECTED')) {
				System.assertEquals(ApexPages.Severity.CONFIRM, msg.getSeverity());
				rejectedMsgFound = true;
				break;
			}
		}
		System.assert(rejectedMsgFound, 'Rejection message not found.');
		Equipment_Missing_Form__c record = [SELECT Status__c, Description__c FROM Equipment_Missing_Form__c];
		System.assertEquals(EquipmentUtilities.REQUEST_STATUS_REJECTED, record.Status__c, 'Status haven\'t been updated or email haven\'t been sent');
		System.assertEquals('Description', record.Description__c, 'Description haven\'t been added to email tempalte.');
		System.assert(!addingFormCtrl.displayPopup, 'Popup window haven\'t closed');
		Test.stopTest();

	}

	@IsTest
	static void addEquipmentRejectedNegativeTest() {

		createSampleData();

		Location__c loc = LocationTestData.createLocation('LocationSource', route.Id, field.Id);
		insert loc;

		Equipment_Missing_Form__c addingForm = new Equipment_Missing_Form__c();
		ApexPages.StandardController stdCtrl = new ApexPages.StandardController(addingForm);
		EquipmentMissingFormControllerX addingFormCtrl = new EquipmentMissingFormControllerX(stdCtrl);
		addingForm = addingFormCtrl.form;
		addingForm.Manufacturer__c = 'TANK';
		addingForm.Manufacturer_Serial_No__c = '123142';
		addingForm.Status__c = EquipmentUtilities.REQUEST_STATUS_OPEN;
		addingForm.Equipment_Status__c = 'Missing';
		addingForm.Location__c = loc.Id;
		addingForm.Location__r = loc;
		addingForm.Description__c = 'Description';
		addingForm.Model_Number__c = 'Test';
		addingFormCtrl.serialPlate.Name = 'upload attachment';
		addingFormCtrl.serialPlate.Body = Blob.valueOf('testing testing');
		addingFormCtrl.attachment.Name = 'upload attachment 1';
		addingFormCtrl.attachment.Body = Blob.valueOf('testing');
		insert addingForm;

		Test.startTest();
		try {
			addingFormCtrl.saveOnPopup();
		} catch (Exception ex) {
			System.assert(ex.getMessage().contains('Add a recipient to send an email.'));
		}
		Equipment_Missing_Form__c record = [SELECT Status__c FROM Equipment_Missing_Form__c];
		System.assertEquals(EquipmentUtilities.REQUEST_STATUS_OPEN, record.Status__c);
		Test.stopTest();
	}

	@IsTest
	static void equipmentTransferServicesPlannerGroups() {

		createSampleData();

		Location__c loc = new Location__c();
		loc.Route__c = route.Id;
		loc.Operating_Field_AMU__c = field.Id;
		insert loc;

		Facility__c fac = new Facility__c();
		fac.Operating_Field_AMU__c = field.Id;
		insert fac;

		Functional_Equipment_Level__c func = new Functional_Equipment_Level__c();
		func.Route__c = route.Id;
		func.Operating_Field_AMU__c = field.Id;
		insert func;

		Yard__c y = new Yard__c();
		y.Route__c = route.Id;
		y.Operating_Field_AMU__c = field.Id;
		insert y;

		System__c sys = new System__c();
		sys.Route__c = route.Id;
		sys.Operating_Field_AMU__c = field.Id;
		insert sys;

		Sub_System__c subSys = new Sub_System__c();
		subSys.Route__c = route.Id;
		subSys.Operating_Field_AMU__c = field.Id;
		insert subSys;

		Well_Event__c we = new Well_Event__c();
		we.Well_ID__c = loc.Id;
		we.Route__c = route.Id;
		insert we;

		Test.startTest();
		String plannerGroup;
		EquipmentFormService service = new EquipmentFormService();
		Equipment_Missing_Form__c eq = new Equipment_Missing_Form__c();
		eq.Location__c = loc.Id;
		eq.Location__r = loc;
		eq.Location__r.Planner_Group__c = '100';
		plannerGroup = service.addEquipmentPlannerGroup(eq);
		System.assertEquals('100', plannerGroup, 'EquipmentFormService returned null.');

		Equipment_Missing_Form__c eq1 = new Equipment_Missing_Form__c();
		eq1.Facility__c = fac.Id;
		eq1.Facility__r = fac;
		eq1.Facility__r.Planner_Group__c = '100';
		plannerGroup = service.addEquipmentPlannerGroup(eq1);
		System.assertEquals('100', plannerGroup, 'EquipmentFormService returned null.');

		Equipment_Missing_Form__c eq2 = new Equipment_Missing_Form__c();
		eq2.Yard__c = y.Id;
		eq2.Yard__r = y;
		eq2.Yard__r.Planner_Group__c = '100';
		plannerGroup = service.addEquipmentPlannerGroup(eq2);
		System.assertEquals('100', plannerGroup, 'EquipmentFormService returned null.');

		Equipment_Missing_Form__c eq3 = new Equipment_Missing_Form__c();
		eq3.Functional_Equipment_Level__c = func.Id;
		eq3.Functional_Equipment_Level__r = func;
		eq3.Functional_Equipment_Level__r.Planner_Group__c = '100';
		plannerGroup = service.addEquipmentPlannerGroup(eq3);
		System.assertEquals('100', plannerGroup, 'EquipmentFormService returned null.');

		Equipment_Missing_Form__c eq4 = new Equipment_Missing_Form__c();
		eq4.Well_Event__c = we.Id;
		eq4.Well_Event__r = we;
		eq4.Well_Event__r.Planner_Group__c = '100';
		plannerGroup = service.addEquipmentPlannerGroup(eq4);
		System.assertEquals('100', plannerGroup, 'EquipmentFormService returned null.');

		Equipment_Missing_Form__c eq5 = new Equipment_Missing_Form__c();
		eq5.System__c = sys.Id;
		eq5.System__r = sys;
		eq5.System__r.Planner_Group__c = '100';
		plannerGroup = service.addEquipmentPlannerGroup(eq5);
		System.assertEquals('100', plannerGroup, 'EquipmentFormService returned null.');

		Equipment_Missing_Form__c eq6 = new Equipment_Missing_Form__c();
		eq6.Sub_System__c = subSys.Id;
		eq6.Sub_System__r = subSys;
		eq6.Sub_System__r.Planner_Group__c = '100';
		plannerGroup = service.addEquipmentPlannerGroup(eq6);
		System.assertEquals('100', plannerGroup, 'EquipmentFormService returned null.');
		Test.stopTest();
	}

	@IsTest
	static void bulkCloseCtrlRejectedTest() {

		createSampleData();

		Location__c loc = LocationTestData.createLocation('LocationSource', route.Id, field.Id);
		insert loc;

		Account acc1 = AccountTestData.createAccount('MojAcc', null);
		insert acc1;

		List<User> user = [SELECT Id, Email FROM User LIMIT 2];
		Contact cnt1 = EquipmentTestData.createContact(acc1.Id, 'Mysko', 'Chinchilla', user[0].Id, 'mysko@chinchilla.ocm');
		insert cnt1;
		Contact cnt2 = EquipmentTestData.createContact(acc1.Id, 'Vlado', 'Putin', user[1].Id);
		insert cnt2;
		HOG_Planner_Group_Notification_Type__c leadMail1 = new HOG_Planner_Group_Notification_Type__c();
		leadMail1.HOG_Planner_Group__c = plannerGroup.Id;
		leadMail1.Contact__c = cnt1.Id;
		leadMail1.Role_Type__c = EquipmentUtilities.ROLE_TRADEMAN_LEAD;
		insert leadMail1;
		HOG_Planner_Group_Notification_Type__c leadMail2 = new HOG_Planner_Group_Notification_Type__c();
		leadMail2.HOG_Planner_Group__c = plannerGroup.Id;
		leadMail2.Contact__c = cnt2.Id;
		leadMail2.Role_Type__c = EquipmentUtilities.ROLE_TRADEMAN_LEAD;
		insert leadMail2;


		//create bulk of "Open" Equipment Transfer Request form for location
		List<Equipment_Missing_Form__c> eq = new List<Equipment_Missing_Form__c>();
		for (Integer i = 0; i < 3; i++) {
			Equipment_Missing_Form__c form = new Equipment_Missing_Form__c();
			form.Manufacturer__c = 'TANK';
			form.Manufacturer_Serial_No__c = '123142';
			form.Status__c = EquipmentUtilities.REQUEST_STATUS_OPEN;
			form.Equipment_Status__c = 'Missing';
			form.Location__c = loc.Id;
			form.Location__r = loc;
			form.Description__c = 'Description';
			form.Model_Number__c = 'Test';
			form.CreatedById = user[0].Id;
			eq.add(form);
		}
		insert eq;


		eq = [
				SELECT Comments__c, Id, Equipment_Status__c, Location__c,
						Manufacturer__c, Manufacturer_Serial_No__c,
						Model_Number__c, Name, Status__c, Tag_Number__c, Serial_plate_of_asset__c, Attachment__c,
						Well_Event__c, System__c, Sub_System__c, Functional_Equipment_Level__c, Yard__c, Facility__c
				FROM Equipment_Missing_Form__c
				WHERE Location__c = :loc.Id
		];


		ApexPages.StandardSetController stdCtrl = new ApexPages.StandardSetController(eq);
		EquipmentMissingFormBulkCloseControllerX setCtrl = new EquipmentMissingFormBulkCloseControllerX(stdCtrl);
		stdCtrl.setSelected(eq);
		setCtrl = new EquipmentMissingFormBulkCloseControllerX(stdCtrl);

		Test.startTest();
		PageReference pageRef = Page.EquipmentCorrectionBulkClose;
		Test.setCurrentPage(pageRef);
		pageRef.getParameters().put('retURL', loc.Id);
		setCtrl.exit();
		for (Equipment_Missing_Form__c equipment : eq) {
			equipment.Location__r = loc;
			equipment.Location__r.Planner_Group__c = '100';
		}
		setCtrl.rejectAndNotify();
		System.assert(setCtrl.displayPopup, 'Popup window haven\'t been shown');
		setCtrl.saveOnPopup();

		Integer invocations = Limits.getEmailInvocations();
		System.assertEquals(1, invocations, 'Email haven\'t been sent.');
		Boolean rejectedMsgFound = false;
		for (ApexPages.Message msg : ApexPages.getMessages()) {
			if (msg.getDetail().contains('REJECTED')) {
				System.assertEquals(ApexPages.Severity.CONFIRM, msg.getSeverity());
				rejectedMsgFound = true;
				break;
			}
		}
		System.assert(rejectedMsgFound, 'Rejection message not found.');
		Equipment_Missing_Form__c record = [SELECT Status__c, Description__c FROM Equipment_Missing_Form__c WHERE Status__c = :EquipmentUtilities.REQUEST_STATUS_REJECTED];
		System.assertEquals(EquipmentUtilities.REQUEST_STATUS_REJECTED, record.Status__c, 'Status haven\'t been updated or email haven\'t been sent');
		System.assertEquals('Description', record.Description__c, 'Description haven\'t been added to email tempalte.');
		System.assert(!setCtrl.displayPopup, 'Popup window haven\'t closed');
		Test.stopTest();
	}

	@IsTest
	static void bulkCloseCtrlRejectedNegativeTest() {

		createSampleData();

		Location__c loc = LocationTestData.createLocation('LocationSource', route.Id, field.Id);
		insert loc;

		Account acc1 = AccountTestData.createAccount('MojAcc', null);
		insert acc1;

		List<User> user = [SELECT Id, Email FROM User LIMIT 2];
		Contact cnt1 = EquipmentTestData.createContact(acc1.Id, 'Mysko', 'Chinchilla', user[0].Id, 'mysko@chinchilla.ocm');
		insert cnt1;
		Contact cnt2 = EquipmentTestData.createContact(acc1.Id, 'Vlado', 'Putin', user[1].Id);
		insert cnt2;
		HOG_Planner_Group_Notification_Type__c leadMail1 = new HOG_Planner_Group_Notification_Type__c();
		leadMail1.HOG_Planner_Group__c = plannerGroup.Id;
		leadMail1.Contact__c = cnt1.Id;
		leadMail1.Role_Type__c = EquipmentUtilities.ROLE_TRADEMAN_LEAD;
		insert leadMail1;
		HOG_Planner_Group_Notification_Type__c leadMail2 = new HOG_Planner_Group_Notification_Type__c();
		leadMail2.HOG_Planner_Group__c = plannerGroup.Id;
		leadMail2.Contact__c = cnt2.Id;
		leadMail2.Role_Type__c = EquipmentUtilities.ROLE_TRADEMAN_LEAD;
		insert leadMail2;


		//create bulk of "Open" Equipment Transfer Request form for location
		List<Equipment_Missing_Form__c> eq = new List<Equipment_Missing_Form__c>();
		for (Integer i = 0; i < 3; i++) {
			Equipment_Missing_Form__c form = new Equipment_Missing_Form__c();
			form.Manufacturer__c = 'TANK';
			form.Manufacturer_Serial_No__c = '123142';
			form.Status__c = EquipmentUtilities.REQUEST_STATUS_OPEN;
			form.Equipment_Status__c = 'Missing';
			form.Location__c = loc.Id;
			form.Location__r = loc;
			form.Description__c = 'Description';
			form.Model_Number__c = 'Test';
			form.CreatedById = user[0].Id;
			eq.add(form);
		}
		insert eq;


		eq = [
				SELECT Comments__c, Id, Equipment_Status__c, Location__c,
						Manufacturer__c, Manufacturer_Serial_No__c,
						Model_Number__c, Name, Status__c, Tag_Number__c, Serial_plate_of_asset__c, Attachment__c,
						Well_Event__c, System__c, Sub_System__c, Functional_Equipment_Level__c, Yard__c, Facility__c
				FROM Equipment_Missing_Form__c
				WHERE Location__c = :loc.Id
		];


		ApexPages.StandardSetController stdCtrl = new ApexPages.StandardSetController(eq);
		EquipmentMissingFormBulkCloseControllerX setCtrl = new EquipmentMissingFormBulkCloseControllerX(stdCtrl);
		stdCtrl.setSelected(eq);
		setCtrl = new EquipmentMissingFormBulkCloseControllerX(stdCtrl);

		Test.startTest();
		try {
			setCtrl.saveOnPopup();
		} catch (Exception ex) {
			System.assert(ex.getMessage().contains('Add a recipient to send an email.'));
		}
		List<Equipment_Missing_Form__c> record = [SELECT Status__c FROM Equipment_Missing_Form__c];
		for (Equipment_Missing_Form__c test : eq) {
			System.assertEquals(EquipmentUtilities.REQUEST_STATUS_OPEN, test.Status__c);
		}
		Test.stopTest();
	}

	@IsTest
	public static void scheduleWithDefaultCron() {

		createSampleData();

		Equipment_Missing_Form__c requestOpen = new Equipment_Missing_Form__c();
		requestOpen.Expiration_Date__c = Date.today();
		requestOpen.Status__c = EquipmentUtilities.REQUEST_STATUS_OPEN;
		insert requestOpen;

		Equipment_Missing_Form__c requestRejected = new Equipment_Missing_Form__c();
		requestRejected.Expiration_Date__c = Date.today();
		requestRejected.Status__c = EquipmentUtilities.REQUEST_STATUS_REJECTED;
		insert requestRejected;

		Equipment_Missing_Form__c requestNotification = new Equipment_Missing_Form__c();
		requestNotification.Expiration_Date__c = Date.today() + 10;
		requestNotification.Status__c = EquipmentUtilities.REQUEST_STATUS_REJECTED;
		insert requestNotification;

		Test.startTest();
		Id jobId = EquipmentExpirationScheduler.schedule();
		Test.stopTest();
		CronTrigger job = [SELECT CronExpression FROM CronTrigger WHERE Id = :jobId];
		System.assertEquals(EquipmentExpirationScheduler.DEFAULT_CRON_STRING, job.CronExpression);
	}
}